jQuery(function ($) {
    var inputString = new Url(Settings.feedUrl).path.split('/')[1];
    if(inputString == ''){inputString = 'Google';}
    var apiKeys=['688699674607483|uwx7npEtFZaRmkQU_RLuPLXKWKQ','688699561274161|fzc6e_GW7jk6tnLN1RdrwhsWPBY','688735067937277|fvDCB4k1QWvTvlhwmxRa8nr_yA0','688735291270588|iCram5V-qwwDqWQG4JqxwxHCLdQ'],
        apiKey = apiKeys[Math.floor(Math.random()*apiKeys.length)],
        $container = $('#posts'),
        $containerFoto = $('#photo'),
        $background = $('#backgrounds'),
        $backgroundImages = $('#backgrounds-images'),
        standardUrlPost = 'https://graph.facebook.com/'+inputString+'/posts/?access_token='+apiKey+'',
        standardUrlPhoto = 'https://graph.facebook.com/'+inputString+'/photos/?type=uploaded&access_token='+apiKey+'';
    $('body').css({backgroundColor: '#'+Settings.bgColor});
    $('.collection').css({backgroundColor: '#'+Settings.bgColor});
    $('#fixed').css({backgroundColor: '#'+Settings.hdTextColor});

    /**
     * ===================================================== Лайки, коверы, и т.п ===================================================
     */
    // Получаем имя запр-ой страницы
    function getNamePage(div){$.getJSON('https://graph.facebook.com/'+inputString+'/?&access_token='+apiKey+'', function(data) {
        $(div).append('<span class="truncate">'+data.name+'</span>');
        $('#name').append(data.name);
    });}
    // Получаем logo запр-ой страницы
    function getLogoPage(){$('#logo').append('<div class="img" style="background-image: url(https://graph.facebook.com/'+inputString+'/picture?&access_token='+apiKey+')"></div>');}
    // Получаем изображение поста
    function getImagePost(id){
        $.getJSON('https://graph.facebook.com/'+id+'?fields=full_picture,picture&access_token='+apiKey+'',
            function(img) {
                if(img.full_picture !== undefined){
                    $('[data-id = fbPost-'+id+'] > img').attr('src', img.full_picture);
                }else{
                    $('[data-id = fbPost-'+id+'] > img').detach();
                }
            }
        )
    }
    // Получаем суммарное количество лайков и комментов
    function getLikeAndGetCommentsPage(id){
        $.getJSON('https://graph.facebook.com/'+id+'/likes?summary=true&access_token='+apiKey+'', function(like) {
            var $like = $('#like_'+id);
            if($like.text() == ''){
                $like.append('<span>'+numeral(like.summary.total_count).format('0a')+'</span>');
            }else{
                $like.detach();
                $like.append('<span>'+numeral(like.summary.total_count).format('0a')+'</span>');
            }
        })
        $.getJSON('https://graph.facebook.com/'+id+'/comments?summary=true&access_token='+apiKey+'', function(comment) {
            var $comment = $('#comment_'+id);
            if($comment.text() == ''){
                $comment.append('<span>'+numeral(comment.summary.total_count).format('0a')+'</span>');
            }else{
                $comment.detach();
                $comment.append('<span>'+numeral(comment.summary.total_count).format('0a')+'</span>');
            }
        })
    }
    // Получаем cover изображение, если его нету, ебанем другие стили и возьмем мини изображение
    function getCoverPage(){
        $.getJSON('https://graph.facebook.com/'+inputString+'?fields=cover&access_token='+apiKey+'', function(data) {
            if(data.cover !== undefined){
                $background.attr("src", ""+data.cover.source+"");
            }else{
                $backgroundImages.append('<div class="img" style="background-image: url(https://graph.facebook.com/'+inputString+'/picture?&access_token='+apiKey+')"></div>');
                $('head').append('<link href="css/no-cover.css" type="text/css" rel="stylesheet" media="screen,projection"/>')
            }
        });
        getPostPage();
    }

    /**
     * ===================================================== Получаем Посты ===================================================
     */

    // Получаем посты
    function getPostPage() {
        $.getJSON(standardUrlPost, function(data) {
            //Пользователь долистал до низа страницы
            getNewPostPage(data.paging.next);
            console.log(data);
            if('AppsgeyserJSInterface' in window){
                AppsgeyserJSInterface.setItem('lastPostTime', data.data[0].created_time);
            }
            $.each( data.data, function( key, value ) {
                // Проверка на существование сообщения, если нету, то ебнем че-нить другое
                if(value.message !== undefined){message = value.message;}else{message = value.story;}
                getLikeAndGetCommentsPage(value.id);
                $container.append(
                    '<li class="collection-item avatar z-depth-2"  data-id="fbPost-'+value.id+'">'+
                    '<img src="'+getImagePost(value.id)+'">'+ // Да хуйня, за-то работает и не плохо работает...
                    '<p>'+linkify(message)+' </p> ' +
                    '<div id="stat-fb">' +
                    '<div class="row">' +
                    '<div class="col s4 m5 l5" id="like_'+value.id+'"><i class="mdi-action-favorite"></i></div>'+
                    '<div class="col s4 m5 l5" id="comment_'+value.id+'"><i class="mdi-communication-messenger"></i></div>'+
                    '</div>' +
                    '</div>' +
                    '<a data-id="'+value.id+'" id="link" style="background-color: #'+Settings.hdColor+';"class="waves-effect waves-light btn"><i class="material-icons left"></i>Go to post</a>'+
                    '</li>'
                );
            });
        });
    }
    function getNewPostPage(next) {
        var inProgress = false;var url = next;
        $(window).scroll(function() {
            if($(window).scrollTop() + $(window).height() >= $(document).height() - 200 && !inProgress) {
                $.ajax({url: url,method: 'GET',beforeSend: function() {inProgress = true;}}).done(function(data){
                    if(data.data == undefined){
                        $('.progress').fadeOut();
                    }else if(data.data == ''){
                        $('.progress').fadeOut();
                    }else{
                        $('.progress').fadeIn();
                    }
                    if (data.data.length > 0) {url = data.paging.next;
                        $.each( data.data, function( key, value ) {
                            // Проверка на существование сообщения, если нету, то ебнем че-нить другое
                            if(value.message !== undefined){message = value.message;}else{message = value.story;}
                            getLikeAndGetCommentsPage(value.id);
                            $container.append(
                                '<li class="collection-item avatar z-depth-2"  data-id="fbPost-'+value.id+'">'+
                                '<img src="'+getImagePost(value.id)+'">'+ // Да хуйня, за-то работает и не плохо работает...
                                '<p>'+linkify(message)+' </p> ' +
                                '<div id="stat-fb">' +
                                '<div class="row">' +
                                '<div class="col s4 m5 l5" id="like_'+value.id+'"><i class="mdi-action-favorite"></i></div>'+
                                '<div class="col s4 m5 l5" id="comment_'+value.id+'"><i class="mdi-communication-messenger"></i></div>'+
                                '</div>' +
                                '</div>' +
                                '<a data-id="'+value.id+'" id="link" style="background-color: #'+Settings.hdColor+';"class="waves-effect waves-light btn"><i class="material-icons left"></i>Go to post</a>'+
                                '</li>'
                            );
                        });
                        inProgress = false;
                    }
                });
            }
        });
    }
    /**
     * =============================================== Работа с контентом фото =====================================================================
     */
    // Получаем фото
    function getPhotoPage() {
        $.getJSON(standardUrlPhoto, function(data) {
            getNewAlbumsPage(data.paging.next);
            $.each( data.data, function( key, value ) {
                $containerFoto.append(
                    '<div class="imag-photo" id="'+value.id+'" data-src="https://graph.facebook.com/'+value.id+'/picture?type=normal&access_token='+apiKey+'" >' +
                    '<div style="background-image: url(https://graph.facebook.com/'+value.id+'/picture?type=normal&access_token='+apiKey+');  width: 100%;height: 80px;background-size: cover;" id="'+value.id+'" ' +
                    'class="zoom-images" >' +
                    '</div>'
                );
            });
        });
    }
    // Получаем альбомы при скроллинге
    function getNewAlbumsPage(next) {
        console.log(next);
        var inProgress = false;var url = next;
        $(window).scroll(function() {
            if($(window).scrollTop() + $(window).height() >= $(document).height() - 200 && !inProgress) {
                $.ajax({url: url,method: 'GET',beforeSend: function() {inProgress = true;}}).done(function(data){
                    if(data.data == undefined){
                        $('.progress').fadeOut();
                    }else if(data.data == ''){
                        $('.progress').fadeOut();
                    }else{
                        $('.progress').fadeIn();
                    }
                    if (data.data.length > 0) {
                        url = data.paging.next;
                        $.each( data.data, function( key, value ) {
                            $containerFoto.append(
                                '<div class="imag-photo" id="'+value.id+'" data-src="https://graph.facebook.com/'+value.id+'/picture?type=normal&access_token='+apiKey+'" >' +
                                '<div style="background-image: url(https://graph.facebook.com/'+value.id+'/picture?type=normal&access_token='+apiKey+');  width: 100%;height: 80px;background-size: cover;" id="'+value.id+'" ' +
                                'class="zoom-images" >' +
                                '</div>'
                            );
                        });
                        inProgress = false;
                    }
                });
            }
        });
    }
    $(document).on('click', '.imag-photo', function(){
        $('body').prepend('<div id="photos" class="valign-wrapper">' +
            '<img src="https://graph.facebook.com/'+this.id+'/picture?type=normal&access_token='+apiKey+'" id="images-photo" />' +
            '</div>')
    });
    $(document).on('click', '#photos', function(){
        $('#photos').detach();
    });
    window.onscroll = function() {
        var scrolled = window.pageYOffset || document.documentElement.scrollTop;
        if(scrolled >= 0 ){
            $('#photos').detach();
        }
    }
    /**
     * =============================================== Нужная херня =====================================================================
     */

        //Псевдо параллакс
    window.requestAnimationFrame = window.requestAnimationFrame
        || window.mozRequestAnimationFrame
        || window.webkitRequestAnimationFrame
        || window.msRequestAnimationFrame
        || function(f){setTimeout(f, 1000/60)};
    window.addEventListener('scroll', function(){ // on page scroll
        requestAnimationFrame(parallaxbubbles) // call parallaxbubbles() on next available screen paint
    }, false)
    function parallaxbubbles(){
        var $main = $('body');
        var scrolltop = window.pageYOffset;
        $('#fixed').css({opacity: scrolltop / 100 * 1.3});
        $('#background').css({transform: 'translate3d(0px, '+scrolltop / 0.5 * 0.5 +'%, 0px)'})
    }


    getNamePage('#fixed');
    getLogoPage();
    //  табы
    function openThePage(id) {
        var close_block = '';
        if(id == 'one'){
            close_block = 'two'
            $('#one').detach();
            $('#fixed').append('<div id="two" class="right"><i class="mdi-image-camera-alt"></i></div>');
        }else{
            close_block = 'one';
            $('#two').detach();
            $('#fixed').append('<div id="one" class="right"><i class="mdi-action-home"></i></div>');
        }
        var $content = $('#content.'+id);
        var $contentclose_block = $('#content.'+close_block);
        if($content.hasClass('active-block') != true){
            $content.addClass('active-block');
            $contentclose_block.removeClass('active-block');
            if(id == 'one'){getPostPage();}else{getPhotoPage();}
        }
    }
    $(document).on('click', '.mdi-action-home ', function(){openThePage('one');});
    $(document).on('click', '.mdi-image-camera-alt ', function(){openThePage('two');});
    $(document).on('click', '#link', function(){var id = $(this).data('id').split('_');location.href = 'https://www.facebook.com/'+inputString+'/posts/'+id[1]+'';});
    // ссылки в тексте активными*
    function linkify(inputText) {
        var replacedText, replacePattern1, replacePattern2, replacePattern3;

        //URLs starting with http://, https://, or ftp://
        replacePattern1 = /(\b(https?|ftp):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/gim;
        replacedText = inputText.replace(replacePattern1, '<a href="$1" target="_blank">$1</a>');

        //URLs starting with "www." (without // before it, or it'd re-link the ones done above).
        replacePattern2 = /(^|[^\/])(www\.[\S]+(\b|$))/gim;
        replacedText = replacedText.replace(replacePattern2, '$1<a href="http://$2" target="_blank">$2</a>');

        //Change email addresses to mailto:: links.
        replacePattern3 = /(\s(g\.co)\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/gim;
        replacedText = replacedText.replace(replacePattern3, '<a href="$1">$1</a>');

        return replacedText;
    }

    // enb\dis notifications
    $(document).on('click', '#notifications',function(){
        var value = $(this).prop("checked");
        if('AppsgeyserJSInterface' in window){
            AppsgeyserJSInterface.setItem('notifications',value);
        }
    });
    if('AppsgeyserJSInterface' in window){
        AppsgeyserJSInterface.setItem('inputString',inputString);
        console.log('run checker')
        var ONE_HOUR = 1000 * 60 * 60;

        var notifications = AppsgeyserJSInterface.getItem('notifications');
        console.log(notifications);
        if(notifications !== 'false' ){
            AppsgeyserJSInterface.setItem('notifications',true);
            AppsgeyserJSInterface.registerUpdateChecker('checker.html', ONE_HOUR);
            $('#notifications').prop('checked', true);
        }else{
            AppsgeyserJSInterface.setItem('notifications',false);
            AppsgeyserJSInterface.removeUpdateChecker('checker.html');
            $('#notifications').prop('checked', false);
        }
    }
    getCoverPage();
});